<?php
/* Autor...:  */
/* Esquema.: MST_UnidadMast.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Metodos de acceso a los campos de la tabla MST_UnidadMast */
abstract class BaseMST_UnidadMastBN
{
    /* Campos de la tabla */
    private $s_IdUnidad;    // IdUnidad: ( no definido )
    private $s_DescripcionCorta;    // DescripcionCorta: ( no definido )
    private $s_DescripcionExtranjera;    // DescripcionExtranjera: ( no definido )
    private $s_CodigoSunat;    // CodigoSunat: ( no definido )
    private $s_UnidadTipo;    // UnidadTipo: ( no definido )
    private $i_NumeroDecimales;    // NumeroDecimales: ( no definido )
    private $i_UnidadEquivalenteFlag;    // UnidadEquivalenteFlag: ( no definido )
    private $i_UsoFraccionFlag;    // UsoFraccionFlag: ( no definido )
    private $i_EsUnidadMinimaFlag;    // EsUnidadMinimaFlag: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )

    /* Establece el valor del campo IdUnidad */
    public function setIdUnidad( $s_IdUnidad )
    {
        $this->s_IdUnidad = $s_IdUnidad;
    }

    /* Obtiene el valor del campo IdUnidad */
    public function getIdUnidad()
    {
        return $this->s_IdUnidad;
    }

    /* Establece el valor del campo DescripcionCorta */
    public function setDescripcionCorta( $s_DescripcionCorta )
    {
        $this->s_DescripcionCorta = $s_DescripcionCorta;
    }

    /* Obtiene el valor del campo DescripcionCorta */
    public function getDescripcionCorta()
    {
        return $this->s_DescripcionCorta;
    }

    /* Establece el valor del campo DescripcionExtranjera */
    public function setDescripcionExtranjera( $s_DescripcionExtranjera )
    {
        $this->s_DescripcionExtranjera = $s_DescripcionExtranjera;
    }

    /* Obtiene el valor del campo DescripcionExtranjera */
    public function getDescripcionExtranjera()
    {
        return $this->s_DescripcionExtranjera;
    }

    /* Establece el valor del campo CodigoSunat */
    public function setCodigoSunat( $s_CodigoSunat )
    {
        $this->s_CodigoSunat = $s_CodigoSunat;
    }

    /* Obtiene el valor del campo CodigoSunat */
    public function getCodigoSunat()
    {
        return $this->s_CodigoSunat;
    }

    /* Establece el valor del campo UnidadTipo */
    public function setUnidadTipo( $s_UnidadTipo )
    {
        $this->s_UnidadTipo = $s_UnidadTipo;
    }

    /* Obtiene el valor del campo UnidadTipo */
    public function getUnidadTipo()
    {
        return $this->s_UnidadTipo;
    }

    /* Establece el valor del campo NumeroDecimales */
    public function setNumeroDecimales( $i_NumeroDecimales )
    {
        $this->i_NumeroDecimales = $i_NumeroDecimales;
    }

    /* Obtiene el valor del campo NumeroDecimales */
    public function getNumeroDecimales()
    {
        return $this->i_NumeroDecimales;
    }

    /* Establece el valor del campo UnidadEquivalenteFlag */
    public function setUnidadEquivalenteFlag( $i_UnidadEquivalenteFlag )
    {
        $this->i_UnidadEquivalenteFlag = $i_UnidadEquivalenteFlag;
    }

    /* Obtiene el valor del campo UnidadEquivalenteFlag */
    public function getUnidadEquivalenteFlag()
    {
        return $this->i_UnidadEquivalenteFlag;
    }

    /* Establece el valor del campo UsoFraccionFlag */
    public function setUsoFraccionFlag( $i_UsoFraccionFlag )
    {
        $this->i_UsoFraccionFlag = $i_UsoFraccionFlag;
    }

    /* Obtiene el valor del campo UsoFraccionFlag */
    public function getUsoFraccionFlag()
    {
        return $this->i_UsoFraccionFlag;
    }

    /* Establece el valor del campo EsUnidadMinimaFlag */
    public function setEsUnidadMinimaFlag( $i_EsUnidadMinimaFlag )
    {
        $this->i_EsUnidadMinimaFlag = $i_EsUnidadMinimaFlag;
    }

    /* Obtiene el valor del campo EsUnidadMinimaFlag */
    public function getEsUnidadMinimaFlag()
    {
        return $this->i_EsUnidadMinimaFlag;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdUnidad' => $this->getIdUnidad(),
            'DescripcionCorta' => $this->getDescripcionCorta(),
            'DescripcionExtranjera' => $this->getDescripcionExtranjera(),
            'CodigoSunat' => $this->getCodigoSunat(),
            'UnidadTipo' => $this->getUnidadTipo(),
            'NumeroDecimales' => $this->getNumeroDecimales(),
            'UnidadEquivalenteFlag' => $this->getUnidadEquivalenteFlag(),
            'UsoFraccionFlag' => $this->getUsoFraccionFlag(),
            'EsUnidadMinimaFlag' => $this->getEsUnidadMinimaFlag(),
            'Estado' => $this->getEstado(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_UnidadMastBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_UnidadMastRs )
    {
        $o_MST_UnidadMastBN = new MST_UnidadMastBN();
        $o_MST_UnidadMastBN->setIdUnidad( $o_MST_UnidadMastRs[ "IdUnidad" ] );
        $o_MST_UnidadMastBN->setDescripcionCorta( $o_MST_UnidadMastRs[ "DescripcionCorta" ] );
        $o_MST_UnidadMastBN->setDescripcionExtranjera( $o_MST_UnidadMastRs[ "DescripcionExtranjera" ] );
        $o_MST_UnidadMastBN->setCodigoSunat( $o_MST_UnidadMastRs[ "CodigoSunat" ] );
        $o_MST_UnidadMastBN->setUnidadTipo( $o_MST_UnidadMastRs[ "UnidadTipo" ] );
        $o_MST_UnidadMastBN->setNumeroDecimales( ( integer ) $o_MST_UnidadMastRs[ "NumeroDecimales" ] );
        $o_MST_UnidadMastBN->setUnidadEquivalenteFlag( ( integer ) $o_MST_UnidadMastRs[ "UnidadEquivalenteFlag" ] );
        $o_MST_UnidadMastBN->setUsoFraccionFlag( ( integer ) $o_MST_UnidadMastRs[ "UsoFraccionFlag" ] );
        $o_MST_UnidadMastBN->setEsUnidadMinimaFlag( ( integer ) $o_MST_UnidadMastRs[ "EsUnidadMinimaFlag" ] );
        $o_MST_UnidadMastBN->setEstado( $o_MST_UnidadMastRs[ "Estado" ] );
        $o_MST_UnidadMastBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_UnidadMastRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_MST_UnidadMastBN->setUsuarioModificacion( $o_MST_UnidadMastRs[ "UsuarioModificacion" ] );
        $o_MST_UnidadMastBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_UnidadMastRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_UnidadMastBN->setUsuarioCreacion( $o_MST_UnidadMastRs[ "UsuarioCreacion" ] );
        return $o_MST_UnidadMastBN;
    }
}
?>